"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const async_hooks = __importStar(require("async_hooks"));
const map = new Map();
async_hooks.createHook({
    destroy: (asyncId) => {
        map.delete(asyncId);
    },
    init: (asyncId, type, triggerAsyncId, resource) => {
        map.set(asyncId, { asyncId, parent: map.get(triggerAsyncId) });
    },
}).enable();
function executionAsyncNode() {
    const asyncId = async_hooks.executionAsyncId();
    let node = map.get(asyncId);
    if (!node) {
        node = { asyncId };
        map.set(asyncId, node);
    }
    return node;
}
exports.executionAsyncNode = executionAsyncNode;
//# sourceMappingURL=node.js.map